#pragma once
#define _WIN32_WINNT 0x0500
#include <windows.h>
#include <windowsx.h>	//ComboBox_ResetContent
#include <setupapi.h>	//SetupDiGetClassDevs
#include <devguid.h>	//GUID_DEVCLASS_PORTS
#include <tchar.h>	//_stscanf
#include <stdio.h>	//sscanf
#pragma intrinsic(memset)

#define elemof(x) (sizeof(x)/sizeof(*(x)))

#ifndef SetWindowLongPtr	// fr MSVC6-SDK nachreichen
# define SetWindowLongPtr SetWindowLong
# define DWLP_MSGRESULT DWL_MSGRESULT
# define INT_PTR INT
#endif

#ifdef _DEBUG	// Ausgabeformat passend zu Visual Studio
# define assert(x) if (!(x)) debug((TEXT("%hs(%u) : Assert failed: %hs\n"),__FILE__,__LINE__,#x))
# define debug(x) debugOut x
#else
# define assert(x) do{}while(0)
# define debug(x) do{}while(0)
#endif

//main.cpp
void _cdecl debugOut(TCHAR*t,...);
extern HWND hMainWnd;
extern TCHAR listcaptions[4096];	// multi_sz

struct RECTS{
 short l,t,r,b;
 short w() const {return r-l;}
 short h() const {return b-t;}
 void operator=(const RECT&rc) {l=short(rc.left); t=short(rc.top); r=short(rc.right); b=short(rc.bottom);}
 void setRect(RECT&rc) const {SetRect(&rc,l,t,r,b);}
};

extern struct Config{
 RECTS rc;	// Fensterposition und -gre
 char showcmd;	// normal, maximiert oder Icon
 BYTE comnr;	// COM-Port-Nummer, 0-basiert
 short hdiv;	// horizontale Fensterteilung in Pixel
 BYTE cwParams[4];	// Spaltenbreiten Parameter
 BYTE cwValues[2];	// Spaltenbreiten Werte
 bool load(const TCHAR*devicecode=0);
 bool save(const TCHAR*devicecode=0) const;
}config;


//worker.cpp
extern struct Worker{
 HANDLE hStop;
 HANDLE hThread;
 DWORD threadId;
 static DWORD CALLBACK ThreadProc(void*);
 DWORD ThreadProc();
 bool start();
 bool stop();
}worker;
